#include "abr.h"

typedef struct Tabr * abr;
struct Tabr {
    abr autre;		/* structure d'arbre binaire */
    abr suivant;
    char lettre;	/* tiquette du noeud */
    abr_donnee donnee;	/* contenu dfinit en externe, c'est un pointeur initialis a NULL */
};

abr arbre = NULL;

/* cree une feuille contenant la lettre donne */
abr creer_feuille (char c) {
    abr feuille = NULL;
    if ((feuille = (abr)malloc (sizeof (struct Tabr))) == NULL)
	perror ("creer_feuille : malloc()");
    feuille->autre = feuille->suivant = NULL;
    feuille->donnee = NULL;
    feuille->lettre = c;
    return feuille;
}

/* renvoie la donnee du mot */
abr_donnee do_donnee_de (abr racine, char * mot) {
/* si le mot n'existe pas ou si l'arbre n'existe pas, renvoie NULL */
    if (mot == NULL)
	return NULL;
    if ((racine == NULL) || !mot[0])
	return NULL;
    
/* se positionne sur la bonne lettre */
    while (mot[0] > racine->lettre)
	if ((racine = racine->autre) == NULL)
	    return NULL;	/* si le mot n'existe pas, renvoie NULL */
    
    if (mot[0] == racine->lettre) {
/* bonne lettre trouve : regarde si c'est la derniere du mot, si oui renvoie la donne */
	if (mot[1])
/* sinon continue rcursivement avec la suite du mot */
	    return do_donnee_de (racine->suivant, ++mot);
	return racine->donnee;
    }
    return NULL;
}
abr_donnee donnee_de (char * mot) {
    return do_donnee_de (arbre, mot);
}

/* renvoie l'arbre auquel on a change la donnee */
abr do_maj_donnee (abr racine, char * mot, abr_donnee donnee) {
    abr feuille = NULL;
    
    if (mot == NULL)		/* vrifie que le mot existe et qu'il n'est pas de longueur nulle */
	return racine;
    if (mot[0] == '\0')
	return racine;
    
/* si le mot n'existe pas dans l'arbre, on le cre */
    if (racine == NULL) {
	feuille = creer_feuille (mot[0]);
	racine = feuille;
    } else if (racine->lettre > mot[0]) {
	feuille = creer_feuille (mot[0]);
	feuille->autre = racine;
	racine = feuille;
    }

    if (racine->lettre == mot[0]) {
	if (mot[1])
	    racine->suivant = do_maj_donnee (racine->suivant, ++mot, donnee);
	else
	    racine->donnee = donnee;
    } else if (racine->lettre < mot[0])
	racine->autre = do_maj_donnee (racine->autre, mot, donnee);
    
    return racine;
}
void maj_donnee (char * mot, abr_donnee donnee) {
    arbre = do_maj_donnee (arbre, mot, donnee);
}

/* supprime le mot de l'arbre */
abr do_suppr_mot (abr racine, char * mot) {
/* pas implment */
/* il faudrait faire une recherche remontante */
    if (mot == NULL)
	return racine;
    if ((racine == NULL) || !mot[0])
	return racine;

    return racine;
}
void suppr_mot (char * mot) {
    arbre = do_suppr_mot (arbre, mot);
}

void do_suppr_abr (abr racine) {
    if (racine == NULL)
	return;
    do_suppr_abr (racine->suivant);
    do_suppr_abr (racine->autre);
    free (racine);
}
void suppr_abr () {
    do_suppr_abr (arbre);
    arbre = NULL;
}
