/** Gestion du fichier des recettes
  @name Module de gestion du fichier des recettes
  @author Pouik et JJ
  @version 0.4
*/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>

extern char errorstr[1024];

/*@{*/

/** Renvoie le nombre de recettes en mmoire
* @param rien
* @precondition rien
* @postcondition rien
*/
unsigned long nbrecettes ();

/** Charge toutes les recettes et leur titre en mmoire
 * @param char * dbfname, char * indexfname
 * @precondition rien
 * @postcondition charge l'ensemble des recettes depuis le fichier dbfname, en utilisant indexfname ou en le crant s'il n'existe pas
 */
void load_recettes (char * dbfname, char * indexfname);

/** Detruit l'ensemble de recettes charges en memoire
 * @param rien
 * @precondition rien
 * @postcondition rien
 */
void destroy_recettes ();

/** Renvoie le titre de la n recette
* @param unsigned long recettenum
* @precondition rien
* @postcondition renvoie le titre de la recette ou NULL
*/
char * recette_titre (unsigned long recettenum);

/** Renvoie le corps de la n recette
* @param unsigned long recettenum
* @precondition rien
* @postcondition renvoie le corps de la recette ou NULL
*/
char * recette_corps (unsigned long recettenum);

/*@}*/
