#include "recherche.h"
#include "fonctionajude.c"

#define NOTEMOTTITRE 5
#define NOTEMOTCORPS 2
#define NOTESYNTITRE 1
#define NOTESYNCORPS 1

//#define gorkfile "/tmp/gork.txt"

struct Treponse {
    Tnote * note; /* note[0] est la note attribuee a la 1 recette */
};

typedef struct Tliste_chainee * liste_chainee;
struct Tliste_chainee {
    liste_chainee suivant;
    unsigned long numrecette;
};
struct Tabr_donnee {
    liste_chainee suivant_titre;
    liste_chainee suivant_corps;
};

unsigned long recettenonnullesuivante (reponse rep, unsigned long recetteini) {
    unsigned long i;
    for (i = recetteini; i < nbrecettes (); i++)
	if (rep->note[i] > 0)
	    break;

/* si on a trouv une recette, on renvoie son numero */
    if (i < nbrecettes ())
	return i;
/* sinon on renvoie du flan */
    return 5000000;
}

Tnote notederecette (reponse rep, unsigned long recettenum) {
/* si l'indice est hors limite, renvoie 0 */
    if ((recettenum < 0) || (recettenum >= nbrecettes ()))
	return 0;
    
/* sinon renvoie la note demande */
    return rep->note[recettenum];
}

void destroyreponse (reponse rep) {
    if (rep != NULL)
	free (rep->note);
    free (rep);
}

reponse recherche (TRequete requete) {
    reponse ret = (reponse)malloc (sizeof (struct Treponse));
    char * mot;
    char * motori;
    unsigned long i;
    abr_donnee abrdonnee = NULL;
    liste_chainee lchainee = NULL;

    if (ret == NULL) {
	strcpy (errorstr, "reponse : malloc()");
	return NULL;
    }
    
    ret->note = (Tnote *)malloc (nbrecettes () * sizeof (Tnote));
    if (ret->note == NULL) {
	strcpy (errorstr, "reponse : malloc()");
	free (ret);
	return NULL;
    }

/* on initialise les notes a 0 */
    for (i = 0; i < nbrecettes (); i++)
	ret->note[i] = 0;
    
    for (i = 0; i < requete_nbmots (requete); i++) {
	mot = requete_mot (requete, i);
	abrdonnee = donnee_de (mot);
	if (abrdonnee == NULL)
/* si le mot n'existe pas, on passe au suivant */
	    continue;

/* on note pour l'apparition dans le titre */
	lchainee = abrdonnee->suivant_titre;
	while (lchainee != NULL) {
	    ret->note[lchainee->numrecette] += NOTEMOTTITRE;
	    lchainee = lchainee->suivant;
	}
	
/* puis dans le corps */
	lchainee = abrdonnee->suivant_corps;
	while (lchainee != NULL) {
	    ret->note[lchainee->numrecette] += NOTEMOTCORPS;
	    lchainee = lchainee->suivant;
	}

/* et on recommence pour chaque synonyme */
	motori = (char *)malloc (strlen (mot) + 1);
	strcpy (motori, mot);

	while (1) {
	    mot = synonyme (mot);
	    if (!strcmp (mot, motori))
/* on s'arrete quand on retombe sur le meme mot */
		break;

	    abrdonnee = donnee_de (mot);
	    if (abrdonnee == NULL)
		continue;

	    lchainee = abrdonnee->suivant_titre;
	    while (lchainee != NULL) {
	/* le mot a un synonyme dans le titre */
		ret->note[lchainee->numrecette] += NOTESYNTITRE;
		lchainee = lchainee->suivant;
	    }

	    lchainee = abrdonnee->suivant_corps;
	    while (lchainee != NULL) {
	/* le mot a un synonyme dans le corps */
		ret->note[lchainee->numrecette] += NOTESYNCORPS;
		lchainee = lchainee->suivant;
	    }
	}
	free (motori);
    }
    return ret;
}

void insere_tete_sans_doublons (liste_chainee * ptete, unsigned long numrecette) {
    liste_chainee nouvtete;
    if (*ptete != NULL) {
	if ((*ptete)->numrecette != numrecette) {
	    nouvtete = (liste_chainee)malloc (sizeof (struct Tliste_chainee));
	    nouvtete->numrecette = numrecette;
	    nouvtete->suivant = (*ptete);
	    *ptete = nouvtete;
	}
    } else {
	nouvtete = (liste_chainee)malloc (sizeof (struct Tliste_chainee));
	nouvtete->numrecette = numrecette;
	nouvtete->suivant = NULL;
	*ptete = nouvtete;
    }
}

#define PRETITRE " <t> "
#define POSTTITRE " </t> "
#define PRECORPS " <c> "
#define POSTCORPS " </c> "

void recherche_initialisation () {
    unsigned long i;
    unsigned long recetteencours = 0;
    int mode = 0;
    char mot[1024];
    char type[1024];
    char fnormale[1024];
    
    FILE * fdtreetagged = NULL;
    FILE * fdtotreetag = NULL;
//FILE * fdgork = NULL;
    char lignetreetag[1024];
    char treetaggedfname[1024];
    char totreetagfname[1024];

    abr_donnee abrdonnee;
    
    sprintf (totreetagfname, "/tmp/treetagging.%ld", (unsigned long)getpid());
    sprintf (treetaggedfname, "/tmp/treetagged.%ld", (unsigned long)getpid());
    
    fdtotreetag = fopen (totreetagfname, "a");
    if (fdtotreetag == NULL) {
	perror ("impossible d'ouvrir le fichier temporaire en ecriture");
	exit (1);
    }
    
    for (i = 0; i < nbrecettes (); i++) {
/* on va mettre dans le fichier les recettes avec les balises qui rulez */
        fwrite (PRETITRE, strlen (PRETITRE), 1, fdtotreetag);
        fwrite (recette_titre (i), strlen (recette_titre (i)), 1, fdtotreetag);
        fwrite (POSTTITRE, strlen (POSTTITRE), 1, fdtotreetag);
        fwrite (PRECORPS, strlen (PRECORPS), 1, fdtotreetag);
        fwrite (recette_corps (i), strlen (recette_corps (i)), 1, fdtotreetag);
        fwrite (POSTCORPS, strlen (POSTCORPS), 1, fdtotreetag);
/* voila */
    }
    fclose (fdtotreetag);
    
    fonctionajude (totreetagfname, treetaggedfname);

/* on efface le fichier un fois qu'il est treetagg */
    unlink (totreetagfname);
    
    fdtreetagged = fopen (treetaggedfname, "r");
//fdgork = fopen (gorkfile, "w");
    recetteencours = 0; /* indicateur de recette en cours */

    while (!feof (fdtreetagged)) {
/* on lit une ligne du retour du treetag */
	fgets (lignetreetag, 1023, fdtreetagged);

	if (lignetreetag[0] != '<') {
/* si ce n'est pas une balise */
	    sscanf (lignetreetag, "%s\t%s\t%s", mot, type, fnormale);

	    if (fnormale[0] == '<') {
/* si le mot est inconnu on prend le mot original */
		strcpy (fnormale, mot);
	    } else {
/* on elimine les mots indesirables */
		if (strlen (type) > 6)
		    if (!strncmp (type, "VER:aux", 7))
/* les auxiliaires */
			continue;
		if ((strncmp (type, "VER", 3) != 0) && (strncmp (type, "NOM", 3) != 0))
/* et tout ce qui n'est ni un verbe ni un nom */
		    continue;
	    }
	    if (strlen (fnormale) < 3)
/* on elimine aussi les mots trop court (gramme, etc...) */
		continue;
	    if (fnormale[0] < 'A')
/* et les chiffres et les mots bizarre */
		continue;


/* on ajoute alors la recette en cours a la liste de references de ce mot */
	    abrdonnee = donnee_de (fnormale);
	    if (abrdonnee == NULL) {
/* le mot n'existe pas : on le cree */
		abrdonnee = (abr_donnee)malloc (sizeof (struct Tabr_donnee));
		if (abrdonnee == NULL) {
		    strcpy (errorstr, "recette_init : malloc ()");
		    return;
		}
		abrdonnee->suivant_titre = abrdonnee->suivant_corps = NULL;
		maj_donnee (fnormale, abrdonnee);
//fwrite (fnormale, strlen (fnormale), 1, fdgork);
//fwrite ("\n", 1, 1, fdgork);
	    }
	    if ((mode == 0) || (mode == 2)) {
/* avant titre ou le corps */
		perror ("On ne devrait pas etre la !");
		break;
	    }
	    if (mode == 1) {
/* dans titre */
		insere_tete_sans_doublons (&abrdonnee->suivant_titre, recetteencours);
	    }
	    if (mode == 3) {
/* dans le corps */
		insere_tete_sans_doublons (&abrdonnee->suivant_corps, recetteencours);
	    }
	} else {
/* on vient de lire une balise : on suppose que c'est une des notres */
	    mode++;
	    if (mode > 3) {
/* on a lu 4 balises donc c'est une nouvelle recette */
		recetteencours++;
		mode = 0;
	    }
	}
    }
    fclose (fdtreetagged);
/* on efface le fichier treetagge qui ne sert plus */
    unlink (treetaggedfname);
fclose (fdgork);
    return;
}

/*@}*/
