/** Module de recherche
   @name Module de recherche
   @author pouik et JJ
   @version 0.2
*/
/*@{*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include "abr.h"
#include "indexator.h"
#include "requetebidon.h"


extern char errorstr[1024];

/** structure de reponse  une demande de recherche de recettes
*/
typedef struct Treponse * reponse;
typedef unsigned long Tnote;


/** Renvoie le numero de la premiere recette non nulle apres n
* @param reponse rep, unsigned long numrecette
* @precondition rep a ete renvoye par recherche()
* @postcondition rien
*/
unsigned long recettenonnullesuivante (reponse rep, unsigned long numrecette);

/** Renvoie la note associee a la num recette dans la reponse rep
* @param reponse rep, unsigned long numrecette
* @precondition rep a ete renvoye par recherche()
* @postcondition rien
*/
Tnote notederecette (reponse rep, unsigned long recettenum);

/** Detruit la structure de donnee contenant les notes
* @param reponse rep
* @precondition rien
* @postcondition rien
*/
void destroyreponse (reponse rep);

/** Renvoie la liste des reponses a la requete
* @param Tindex index, TRequete requete, Reponse reponse
* @precondition Requete est une requete, la liste des recettes est initialise
* @postcondition Reponse est la requete, renvoie 0 sauf si couille
*/
reponse recherche (TRequete requete);

/** Recherche l'ensemble des mots de chaque recette, les treetagge et les classe
 * dans l'arbre binaire, en indiquant pour chaquun dans quelles recettes il
 * apparait
 * @param rien
 * @precondition il faut que l'initialisation d'indexator soit faite
 * @postcondition rien
 */
void recherche_initialisation ();

/*@}*/
